diff --git a/lib/librte_eal/common/include/generic/rte_cpuflags.h b/lib/librte_eal/common/include/generic/rte_cpuflags.h
index 7f04838..a04e021 100644
--- a/lib/librte_eal/common/include/generic/rte_cpuflags.h
+++ b/lib/librte_eal/common/include/generic/rte_cpuflags.h
@@ -89,7 +89,7 @@ rte_cpu_get_features(uint32_t leaf, uint32_t subleaf, cpuid_registers_t out);
 /**
  * Function for checking a CPU flag availability
  *
- * @param flag
+ * @param feature
  *     CPU flag to query CPU for
  * @return
  *     1 if flag is available
diff --git a/lib/librte_eal/common/include/rte_common.h b/lib/librte_eal/common/include/rte_common.h
index c0ab8b4..c6e076b 100644
--- a/lib/librte_eal/common/include/rte_common.h
+++ b/lib/librte_eal/common/include/rte_common.h
@@ -220,8 +220,8 @@ rte_align32pow2(uint32_t x)
 /**
  * Aligns 64b input parameter to the next power of 2
  *
- * @param x
- *   The 64b value to algin
+ * @param v
+ *   The 64b value to align
  *
  * @return
  *   Input parameter aligned to the next power of 2
@@ -303,7 +303,7 @@ rte_bsf32(uint32_t v)
 /** Take a macro value and get a string version of it */
 #define RTE_STR(x) _RTE_STR(x)
 
-/** Mask value of type <tp> for the first <ln> bit set. */
+/** Mask value of type "tp" for the first "ln" bit set. */
 #define	RTE_LEN2MASK(ln, tp)	\
 	((tp)((uint64_t)-1 >> (sizeof(uint64_t) * CHAR_BIT - (ln))))
 
diff --git a/lib/librte_eal/common/include/rte_debug.h b/lib/librte_eal/common/include/rte_debug.h
index 82ee3b3..94129fa 100644
--- a/lib/librte_eal/common/include/rte_debug.h
+++ b/lib/librte_eal/common/include/rte_debug.h
@@ -70,10 +70,8 @@ void rte_dump_registers(void);
  *
  * The function never returns.
  *
- * @param format
- *   The format string
- * @param args
- *   The variable list of arguments.
+ * @param ...
+ *   The format string, followed by the variable list of arguments.
  */
 #define rte_panic(...) rte_panic_(__func__, __VA_ARGS__, "dummy")
 #define rte_panic_(func, format, ...) __rte_panic(func, format "%.0s", __VA_ARGS__)
diff --git a/lib/librte_eal/common/include/rte_devargs.h b/lib/librte_eal/common/include/rte_devargs.h
index 039f728..7084ae2 100644
--- a/lib/librte_eal/common/include/rte_devargs.h
+++ b/lib/librte_eal/common/include/rte_devargs.h
@@ -141,7 +141,7 @@ int rte_eal_parse_devargs_str(const char *devargs_str,
  *
  * @param devtype
  *   The type of the device.
- * @param devargs_list
+ * @param devargs_str
  *   The arguments as given by the user.
  *
  * @return
diff --git a/lib/librte_eal/common/include/rte_eal.h b/lib/librte_eal/common/include/rte_eal.h
index 1385a73..f36a792 100644
--- a/lib/librte_eal/common/include/rte_eal.h
+++ b/lib/librte_eal/common/include/rte_eal.h
@@ -171,7 +171,7 @@ typedef void	(*rte_usage_hook_t)(const char * prgname);
  * This routine is optional for the application and will behave as if the set
  * routine was never called as the default behavior.
  *
- * @param func
+ * @param usage_func
  *   The func argument is a function pointer to the application usage routine.
  *   Called function is defined using rte_usage_hook_t typedef, which is of
  *   the form void rte_usage_func(const char * prgname).
@@ -183,7 +183,7 @@ typedef void	(*rte_usage_hook_t)(const char * prgname);
  *     the caller to daisy chain the usage routines if needing more then one.
  */
 rte_usage_hook_t
-rte_set_application_usage_hook( rte_usage_hook_t usage_func );
+rte_set_application_usage_hook(rte_usage_hook_t usage_func);
 
 /**
  * macro to get the lock of tailq in mem_config
diff --git a/lib/librte_eal/common/include/rte_log.h b/lib/librte_eal/common/include/rte_log.h
index 3b467c1..24a55cc 100644
--- a/lib/librte_eal/common/include/rte_log.h
+++ b/lib/librte_eal/common/include/rte_log.h
@@ -289,11 +289,9 @@ int rte_vlog(uint32_t level, uint32_t logtype, const char *format, va_list ap)
  * @param t
  *   The log type, for example, EAL. The short name is expanded by the
  *   macro, so it cannot be an integer value.
- * @param fmt
+ * @param ...
  *   The fmt string, as in printf(3), followed by the variable arguments
  *   required by the format.
- * @param args
- *   The variable list of arguments according to the format string.
  * @return
  *   - 0: Success.
  *   - Negative on error.
diff --git a/lib/librte_eal/common/include/rte_memzone.h b/lib/librte_eal/common/include/rte_memzone.h
index 81b6ad4..ee62680 100644
--- a/lib/librte_eal/common/include/rte_memzone.h
+++ b/lib/librte_eal/common/include/rte_memzone.h
@@ -258,7 +258,7 @@ const struct rte_memzone *rte_memzone_lookup(const char *name);
  * @param f
  *   A pointer to a file for output
  */
-void rte_memzone_dump(FILE *);
+void rte_memzone_dump(FILE *f);
 
 /**
  * Walk list of all memzones
diff --git a/lib/librte_ether/rte_eth_ctrl.h b/lib/librte_ether/rte_eth_ctrl.h
index 498fc85..9187d6d 100644
--- a/lib/librte_ether/rte_eth_ctrl.h
+++ b/lib/librte_ether/rte_eth_ctrl.h
@@ -109,7 +109,7 @@ enum rte_filter_op {
 	RTE_ETH_FILTER_OP_MAX
 };
 
-/*
+/**
  * MAC filter type
  */
 enum rte_mac_filter_type {
diff --git a/lib/librte_ether/rte_ethdev.h b/lib/librte_ether/rte_ethdev.h
index 04c192d..f1219ac 100644
--- a/lib/librte_ether/rte_ethdev.h
+++ b/lib/librte_ether/rte_ethdev.h
@@ -1040,10 +1040,10 @@ typedef void (*eth_queue_release_t)(void *queue);
 
 typedef uint32_t (*eth_rx_queue_count_t)(struct rte_eth_dev *dev,
 					 uint16_t rx_queue_id);
-/**< @Get number of available descriptors on a receive queue of an Ethernet device. */
+/**< @internal Get number of available descriptors on a receive queue of an Ethernet device. */
 
 typedef int (*eth_rx_descriptor_done_t)(void *rxq, uint16_t offset);
-/**< @Check DD bit of specific RX descriptor */
+/**< @internal Check DD bit of specific RX descriptor */
 
 typedef int (*mtu_set_t)(struct rte_eth_dev *dev, uint16_t mtu);
 /**< @internal Set MTU. */
@@ -1456,8 +1456,8 @@ struct rte_eth_rxtx_callback {
 	void *param;
 };
 
-/*
- * The eth device type
+/**
+ * The eth device type.
  */
 enum rte_eth_dev_type {
 	RTE_ETH_DEV_UNKNOWN,	/**< unknown device type */
@@ -1629,7 +1629,7 @@ int rte_eth_dev_attach(const char *devargs, uint8_t *port_id);
  *
  * @param port_id
  *   The port identifier of the device to detach.
- * @param addr
+ * @param devname
  *  A pointer to a device name actually detached.
  * @return
  *  0 on success and devname is filled, negative on error
@@ -2474,7 +2474,7 @@ rte_eth_rx_queue_count(uint8_t port_id, uint16_t queue_id)
  *  The port identifier of the Ethernet device.
  * @param queue_id
  *  The queue id on the specific port.
- * @offset
+ * @param offset
  *  The offset of the descriptor ID from tail.
  * @return
  *  - (1) if the specific DD bit is set.
@@ -3266,7 +3266,7 @@ int rte_eth_dev_bypass_state_show(uint8_t port, uint32_t *state);
  *
  * @param port
  *   The port identifier of the Ethernet device.
- * @param state
+ * @param new_state
  *   The current bypass state.
  *   - (1) Normal mode
  *   - (2) Bypass mode
@@ -3331,7 +3331,7 @@ int rte_eth_dev_bypass_event_store(uint8_t port, uint32_t event, uint32_t state)
  *
  * @param port
  *   The port identifier of the Ethernet device.
- * @param state
+ * @param timeout
  *   The timeout to be set.
  *   - (0) 0 seconds (timer is off)
  *   - (1) 1.5 seconds
@@ -3560,9 +3560,9 @@ void *rte_eth_add_tx_callback(uint8_t port_id, uint16_t queue_id,
  * since the it may still be in use. The memory for the callback can be
  * subsequently freed back by the application by calling rte_free():
  *
- *  - Immediately - if the port is stopped, or the user knows that no
- *    callbacks are in flight e.g. if called from the thread doing RX/TX
- *    on that queue.
+ * - Immediately - if the port is stopped, or the user knows that no
+ *   callbacks are in flight e.g. if called from the thread doing RX/TX
+ *   on that queue.
  *
  * - After a short delay - where the delay is sufficient to allow any
  *   in-flight callbacks to complete.
@@ -3593,9 +3593,9 @@ int rte_eth_remove_rx_callback(uint8_t port_id, uint16_t queue_id,
  * since the it may still be in use. The memory for the callback can be
  * subsequently freed back by the application by calling rte_free():
  *
- *  - Immediately - if the port is stopped, or the user knows that no
- *    callbacks are in flight e.g. if called from the thread doing RX/TX
- *    on that queue.
+ * - Immediately - if the port is stopped, or the user knows that no
+ *   callbacks are in flight e.g. if called from the thread doing RX/TX
+ *   on that queue.
  *
  * - After a short delay - where the delay is sufficient to allow any
  *   in-flight callbacks to complete.
diff --git a/lib/librte_ether/rte_ether.h b/lib/librte_ether/rte_ether.h
index 49f4576..a14308e 100644
--- a/lib/librte_ether/rte_ether.h
+++ b/lib/librte_ether/rte_ether.h
@@ -277,7 +277,7 @@ static inline void ether_addr_copy(const struct ether_addr *ea_from,
  *   A pointer to buffer contains the formatted MAC address.
  * @param size
  *   The format buffer size.
- * @param ea_to
+ * @param eth_addr
  *   A pointer to a ether_addr structure.
  */
 static inline void
diff --git a/lib/librte_kni/rte_kni.h b/lib/librte_kni/rte_kni.h
index fd2b78f..52ffdb7 100644
--- a/lib/librte_kni/rte_kni.h
+++ b/lib/librte_kni/rte_kni.h
@@ -301,12 +301,7 @@ extern int rte_kni_register_handlers(struct rte_kni *kni,
 extern int rte_kni_unregister_handlers(struct rte_kni *kni);
 
 /**
- *  close KNI device.
- *
- *  @param void
- *
- *  @return
- *   void
+ *  Close KNI device.
  */
 extern void rte_kni_close(void);
 
diff --git a/lib/librte_mempool/rte_mempool.h b/lib/librte_mempool/rte_mempool.h
index a4a9610..bc2bae0 100644
--- a/lib/librte_mempool/rte_mempool.h
+++ b/lib/librte_mempool/rte_mempool.h
@@ -1325,6 +1325,8 @@ struct rte_mempool *rte_mempool_lookup(const char *name);
  *   The flags used for the mempool creation.
  *   Consult rte_mempool_create() for more information about possible values.
  *   The size of each element.
+ * @param sz
+ *   The calculated detailed size the mempool object. May be NULL.
  * @return
  *   Total size of the mempool object.
  */
diff --git a/lib/librte_power/rte_power.h b/lib/librte_power/rte_power.h
index 7d57359..67e0ec0 100644
--- a/lib/librte_power/rte_power.h
+++ b/lib/librte_power/rte_power.h
@@ -68,19 +68,12 @@ int rte_power_set_env(enum power_management_env env);
 /**
  * Unset the global environment configuration.
  * This can only be called after all threads have completed.
- *
- * @param None.
- *
- * @return
- *  None.
  */
 void rte_power_unset_env(void);
 
 /**
  * Get the default power management implementation.
  *
- * @param None.
- *
  * @return
  *  power_management_env The configured environment.
  */
@@ -104,7 +97,6 @@ int rte_power_init(unsigned lcore_id);
  * Exit power management on a specific lcore. This will call the environment
  * dependent exit function.
  *
- *
  * @param lcore_id
  *  lcore id.
  *